{%- from 'components/freigabestatus_badge.html.jinja' import freigabestatus_badge -%}
{%- from 'components/help.html.jinja' import glossary_link -%}

{%- macro _render_report_check(check) -%}
  <li class="d-flex flex-row align-items-center gap-2 mb-1">
    <span class="badge text-bg-light">
      <a
        href="https://docs.fitko.de/fim/docs/datenfelder/QS_Bericht/#M{{ check.code }}"
        target="_blank"
        aria-label="Code {{ check.code }} (öffnet in neuem Tab)"
      >
        Code: {{ check.code }}
      </a>
    </span>
    {{ check.message }}
  </li>
{% endmacro %}

{%- macro _render_report(report) -%}
  <ul class="list-unstyled mb-0">
    {% for check in report.critical %}
      {{ _render_report_check(check) }}
    {% endfor %}
    {% for check in report.method %}
      {{ _render_report_check(check) }}
    {% endfor %}
    {% for check in report.warning %}
      {{ _render_report_check(check) }}
    {% endfor %}
    {% for check in report.info %}
      {{ _render_report_check(check) }}
    {% endfor %}
  </ul>
{%- endmacro -%}

{%- macro _result_card(title) -%}
  <div class="card mb-3">
    <h2 class="fs-6 fw-semibold card-header">{{ title }}</h2>
    {{ caller() }}
  </div>
{%- endmacro -%}

{% macro _empty_card_body() %}
  <div class="card-body">
    <div class="d-flex flex-row align-items-center gap-2">
      <i class="bi bi-check-circle text-success"></i> Keine Probleme gefunden
    </div>
  </div>
{% endmacro %}

{% macro _render_element_report(report) %}
  <div class="list-group-item">
    <div class="d-flex flex-row align-items-center gap-2 mb-2">
      <a class="link-dark" href="{{ report.href }}">
        <b>{{ report.name }}</b>
      </a>
      <span class="text-muted">{{ report.fim_id }}</span>
      {% if report.fim_version %}
        <span class="text-muted">•</span>
        <span class="text-muted">Version {{ report.fim_version }}</span>
      {% endif %}
      {{ freigabestatus_badge(report.freigabe_status) }}
    </div>

    {{ _render_report(report) }}
  </div>
{% endmacro %}

{%- macro render_quality_report(report) -%}
  <div class="mb-3 text-muted">
    <i class="bi bi-info-circle text-primary"></i>
    <a
      class="icon-link"
      href="https://docs.fitko.de/fim/docs/datenfelder/QS_Bericht"
      target="_blank"
      aria-label="Weitere Informationen zu allen Codes (öffnet in neuem Tab)"
    >
      Weitere Informationen zu allen Codes
      <svg class="bi" aria-hidden="true">
        <use xlink:href="#box-arrow-up-right"></use>
      </svg>
    </a>
  </div>

  {% call _result_card("Bericht Datenschema") %}
    {% if report.schema_report %}
      <div class="card-body">{{ _render_report(report.schema_report) }}</div>
    {% else %}
      {{ _empty_card_body() }}
    {% endif %}
  {% endcall %}

  {% call _result_card("Bericht zugehöriger Datenfeldgruppen") %}
    {% if report.group_reports %}
      <div class="list-group list-group-flush">
        {% for report in report.group_reports %}
          {{ _render_element_report(report) }}
        {% endfor %}
      </div>
    {% else %}
      {{ _empty_card_body() }}
    {% endif %}
  {% endcall %}

  {% call _result_card("Bericht zugehöriger Datenfelder") %}
    {% if report.field_reports %}
      <div class="list-group list-group-flush">
        {% for report in report.field_reports %}
          {{ _render_element_report(report) }}
        {% endfor %}
      </div>
    {% else %}
      {{ _empty_card_body() }}
    {% endif %}
  {% endcall %}
{%- endmacro -%}
